题目
链接:https://leetcode-cn.com/problems/task-scheduler
给你一个用字符数组 tasks 表示的 CPU 需要执行的任务列表。其中每个字母表示一种不同种类的任务。任务可以以任意顺序执行,并且每个任务都可以在 1 个单位时间内执行完。在任何一个单位时间,CPU 可以完成一个任务,或者处于待命状态。
然而,两个 相同种类 的任务之间必须有长度为整数 n 的冷却时间,因此至少有连续 n 个单位时间内 CPU 在执行不同的任务,或者在待命状态。
你需要计算完成所有任务所需要的 最短时间 。
贪心
相同任务之间的间隔至少为 n
, 每次取频率最高的n + 1
个任务。频率高的任务应该紧凑的去使用
class Solution {
public int leastInterval(char[] tasks, int n) {
// 记录每个任务出现的频率
int[] counter = new int[26];
for (char task : tasks) {
counter[task - 'A']++;
}
// 按频率将每个任务加入大顶堆
PriorityQueue<Integer> mq = new PriorityQueue<>((x, y)-> y - x);
for (Integer freq : counter) {
if (freq != 0) {
mq.offer(freq);
}
}
n++;
int cnt = 0;
// 每次从大顶堆中取出n个最大的元素
while (!mq.isEmpty()) {
int k = Math.min(n, mq.size());
List<Integer> temp = new ArrayList<>();
for (int i = 0; i < k; i++) {
int freq = mq.poll();
if (freq - 1 > 0) {
temp.add(freq - 1);
}
}
if (k == n) {
cnt += n;
} else if (temp.size () > 0) {
cnt += n;
} else {
cnt += k;
}
for ( Integer freq : temp)
mq.offer(freq);
}
return cnt;
}
}
方法二 另一种贪心
设计桶的大小为 n + 1
这样相同的任务不能放入相同的桶之中,最密也只能放入相邻的桶中,由于要求最短时间,因此要尽可能密的排放任务,所以桶的数量为出现次数最多的任务的频率,将所有的任务尽可能排在相邻的桶中,任务排完后计算需要的空闲时间,如果不需要空闲时间则说明刚好排满,如果需要空闲时间,则最小时间为空间时间加上任务数量。
class Solution {
public int leastInterval(char[] tasks, int n) {
int[] counter = new int[26];
for (char task : tasks) {
counter[task - 'A']++;
}
Arrays.sort(counter);
int maxN = counter[25] - 1;
int space = maxN * n;
for (int i = 24;i >=0 && counter[i] > 0; i--) {
space -= Math.min(maxN, counter[i]);
}
return space > 0 ? space + tasks.length : tasks.length;
}
}